ur_rna.StructureEditor

## Class AppActions

- java.lang.Object
- - ur_rna.StructureEditor.AppActions

-     public abstract class AppActions
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private static Program` | `_app`
    `private static MainFrame` | `_window`
    `static UiAction` | `CLEANUP_RECENT_FILES`
    `static UiAction` | `CLEAR_RECENT_FILES`
    `static UiAction` | `EXIT_PROGRAM`
    `private static java.lang.String` | `FEEDBACK_SECRET`
    `private static java.lang.String` | `FEEDBACK_URL`
    `private static java.lang.String` | `HELP_URL`
    `private static java.lang.String` | `LOCAL_HELP_PAGE`
    `private static java.lang.String[]` | `LOCAL_HELP_URLS`
    `private static AppLog` | `log`
    `static UiAction` | `NEW_FILE`
    `static UiAction` | `OPEN_WEBSITE`
    `static UiAction` | `SEND_FEEDBACK`
    `static UiAction` | `SHOW_ABOUT_WINDOW`
    `static UiAction` | `SHOW_DASHBOARD`
    `static UiAction` | `SHOW_LOCAL_HELP`
    `static UiAction` | `SHOW_ONLINE_HELP`
    `static UiAction` | `SHOW_OPEN_FILE`
    `private static java.lang.String` | `WEB_URL`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AppActions()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static Program` | `app()`
    `static void` | `browse(java.lang.String uri)`
    `private static void` | `browseLocalHelp()`
    `static DrawWindow` | `createEditorWindow(RnaSceneGroup sceneGroup)`
    `private static NucLayout` | `createLayout()`
    `static void` | `createNewFile()`
    `static void` | `exitApp()`
    `static java.lang.String` | `formatFileError(java.lang.String operation, FileType type, java.lang.String path, java.lang.Exception ex)`
    `static void` | `openFile(java.lang.String path, FileType type)`
    `static void` | `openFile(java.lang.String file, java.lang.String type)`
    `static RnaSceneGroup` | `readSceneFile(java.lang.String path, FileType type)`
    `private static void` | `sendFeedbackFromBrowser()`
    `static void` | `showAboutWindow()`
    `static FileType` | `showFileTypePrompt()`
    `static void` | `showOpenFile()`
    `private static java.lang.String` | `urlenc(java.lang.String value)`
    `protected static MainFrame` | `window()`
    `static boolean` | `writeFile(RnaSceneGroup scenes, java.lang.String path, FileType type, boolean asCopy, boolean append)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### _app

          private static Program _app

    - #### _window

          private static MainFrame _window

    - #### CLEANUP_RECENT_FILES

          public static final UiAction CLEANUP_RECENT_FILES

    - #### CLEAR_RECENT_FILES

          public static final UiAction CLEAR_RECENT_FILES

    - #### EXIT_PROGRAM

          public static final UiAction EXIT_PROGRAM

    - #### FEEDBACK_SECRET

          private static final java.lang.String FEEDBACK_SECRET

      See Also:
        Constant Field Values

    - #### FEEDBACK_URL

          private static final java.lang.String FEEDBACK_URL

      See Also:
        Constant Field Values

    - #### HELP_URL

          private static final java.lang.String HELP_URL

      See Also:
        Constant Field Values

    - #### LOCAL_HELP_PAGE

          private static final java.lang.String LOCAL_HELP_PAGE

      See Also:
        Constant Field Values

    - #### LOCAL_HELP_URLS

          private static final java.lang.String[] LOCAL_HELP_URLS

    - #### log

          private static AppLog log

    - #### NEW_FILE

          public static final UiAction NEW_FILE

    - #### OPEN_WEBSITE

          public static final UiAction OPEN_WEBSITE

    - #### SEND_FEEDBACK

          public static final UiAction SEND_FEEDBACK

    - #### SHOW_ABOUT_WINDOW

          public static final UiAction SHOW_ABOUT_WINDOW

    - #### SHOW_DASHBOARD

          public static final UiAction SHOW_DASHBOARD

    - #### SHOW_LOCAL_HELP

          public static final UiAction SHOW_LOCAL_HELP

    - #### SHOW_ONLINE_HELP

          public static final UiAction SHOW_ONLINE_HELP

    - #### SHOW_OPEN_FILE

          public static final UiAction SHOW_OPEN_FILE

    - #### WEB_URL

          private static final java.lang.String WEB_URL

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### AppActions

          public AppActions()

  - ### Method Detail

    - #### app

          protected static Program app()

    - #### browse

          public static void browse(java.lang.String uri)

    - #### browseLocalHelp

          private static void browseLocalHelp()

    - #### createEditorWindow

          public static DrawWindow createEditorWindow(RnaSceneGroup sceneGroup)

    - #### createLayout

          private static NucLayout createLayout()

    - #### createNewFile

          public static void createNewFile()

    - #### exitApp

          public static void exitApp()

    - #### formatFileError

          public static java.lang.String formatFileError(java.lang.String operation,
                                                         FileType type,
                                                         java.lang.String path,
                                                         java.lang.Exception ex)

    - #### openFile

          public static void openFile(java.lang.String path,
                                      FileType type)

    - #### openFile

          public static void openFile(java.lang.String file,
                                      java.lang.String type)

    - #### readSceneFile

          public static RnaSceneGroup readSceneFile(java.lang.String path,
                                                    FileType type)
                                             throws RnaBackendException,
                                                    SyntaxErrorException,
                                                    java.io.IOException

      Throws:
        `RnaBackendException`
        `SyntaxErrorException`
        `java.io.IOException`

    - #### sendFeedbackFromBrowser

          private static void sendFeedbackFromBrowser()

    - #### showAboutWindow

          public static void showAboutWindow()

    - #### showFileTypePrompt

          public static FileType showFileTypePrompt()

    - #### showOpenFile

          public static void showOpenFile()

    - #### urlenc

          private static java.lang.String urlenc(java.lang.String value)

    - #### window

          protected static MainFrame window()

    - #### writeFile

          public static boolean writeFile(RnaSceneGroup scenes,
                                          java.lang.String path,
                                          FileType type,
                                          boolean asCopy,
                                          boolean append)
                                   throws java.io.IOException,
                                          RnaBackendException,
                                          FormatterException

      Throws:
        `java.io.IOException`
        `RnaBackendException`
        `FormatterException`